#include "systemc.h"
#include <iostream>

class ModuleLeft: sc_module {
public:
  SC_HAS_PROCESS(ModuleLeft);

  sc_in<int> port_in;

  ModuleLeft(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    wait(SC_ZERO_TIME);
    wait(SC_ZERO_TIME);
    int value = port_in->read();
    //std::cout << "value: " << value << std::endl;
  }
};

class ModuleRight: sc_module {

public:
  SC_HAS_PROCESS(ModuleRight);

  sc_out<int> port_out;

  ModuleRight(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    wait(SC_ZERO_TIME);
    //std::cout << "writing: " << 55 << std::endl;
    port_out->write(55);
  }
};

class Module: sc_module {

public:

  SC_HAS_PROCESS(Module);

  ModuleRight right;
  ModuleLeft left;

  sc_signal<int> signal;

  Module(sc_module_name mn):
    sc_module(mn),
    right("right"),
    left("left")
  {
  }

  void before_end_of_elaboration()
  {
    left.port_in.bind(signal);
    right.port_out.bind(signal);
  }
};


int sc_main(int argc, char **argv)
{
  Module m("m");
  sc_start();
  return 0;
}

