#ifndef INTERFACE_H_INCLUDED_
#define INTERFACE_H_INCLUDED_

#include "rose.h"

#include "class.h"

namespace risc {

class Interface: public Class {

public:

  /**
   * \brief default constructor
   */
  explicit Interface(SgClassDefinition *ast_node);

  /**
   * \brief Get function for the name of the ast type of the port
   * \return Name as std::string
   */
  virtual std::string get_ast_type_name();

private:
  /**
   * \brief Disabled copy constructor
   */
  Interface(const Interface &i);
};

typedef std::vector<Interface*> InterfaceVector;
typedef std::vector<Interface*>::iterator InterfaceVectorIter;
typedef std::vector<Interface*>::const_iterator InterfaceVectorConstIter;

} // end of namespace risc
#endif /* INTERFACE_H_INCLUDED_ */
