#include "systemc_definitions.h"

namespace risc {

namespace tools {

SgClassDefinition *SystemCDefinitions::sc_module_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_port_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_port_base_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_in_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_out_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_inout_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_event_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_event_and_list_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_event_or_list_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_prim_channel_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_interface_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_fifo_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_fifo_in_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_fifo_out_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_process_b_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_simcontext_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_segid_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_time_ = NULL;

SgClassDefinition *SystemCDefinitions::sc_channel_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_in_clk_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_out_clk_ = NULL;
SgClassDefinition *SystemCDefinitions::sc_inout_clk_ = NULL;

SgClassDefinition *SystemCDefinitions::tlm_base_initiator_socket_b_ = NULL;
SgClassDefinition *SystemCDefinitions::tlm_base_target_socket_b_ = NULL;


SgFunctionDefinition *SystemCDefinitions::sc_main_ = NULL;
SgMemberFunctionDeclaration *SystemCDefinitions::sc_get_curr_proc_ = NULL;
SgMemberFunctionDeclaration *SystemCDefinitions::sc_segid_ctor_ = NULL;
SgFunctionDeclaration *SystemCDefinitions::sc_get_curr_simcontext_ = NULL;
SgFunctionDeclaration *SystemCDefinitions::sc_stop_ = NULL;
SgMemberFunctionDeclaration *SystemCDefinitions::get_upcoming_segment_ids_ = NULL;
SgMemberFunctionDeclaration *SystemCDefinitions::set_upcoming_segment_ids_ = NULL;
SgMemberFunctionDeclaration *SystemCDefinitions::get_upcoming_socket_id_ = NULL;
SgMemberFunctionDeclaration *SystemCDefinitions::set_upcoming_socket_id_ = NULL;


SgMemberFunctionDeclaration *SystemCDefinitions::increase_offset_ = NULL;
SgMemberFunctionDeclaration *SystemCDefinitions::decrease_offset_ = NULL;
SgMemberFunctionDeclaration *SystemCDefinitions::get_offset_ = NULL;

SgMemberFunctionDeclaration *SystemCDefinitions::get_interface_ = NULL;
SgMemberFunctionDeclaration *SystemCDefinitions::get_base_interface_ = NULL;
SgMemberFunctionDeclaration *SystemCDefinitions::get_base_port_ = NULL;

std::vector<SgNamespaceDefinitionStatement*> SystemCDefinitions::sc_core_;
std::vector<SgNamespaceDefinitionStatement*> SystemCDefinitions::sc_dt_;

std::set<SgFunctionDefinition*> SystemCDefinitions::sc_wait_funcs_;

bool SystemCDefinitions::is_initialized_ = false;

void SystemCDefinitions::initialize() // RD: moved here from the header file
{
    if(is_initialized_ == true) {
      return;
    }

    sc_module_ = NULL;
    sc_port_ = NULL;
    sc_port_base_ = NULL;
    sc_in_ = NULL;
    sc_out_ = NULL;
    sc_inout_ = NULL;
    sc_event_ = NULL;
    sc_event_and_list_ = NULL;
    sc_event_or_list_ = NULL;
    sc_prim_channel_ = NULL;
    sc_interface_ = NULL;
    sc_channel_ = NULL;
    sc_in_clk_ = NULL;
    sc_out_clk_ = NULL;
    sc_inout_clk_ = NULL;
    sc_fifo_ = NULL;
    sc_fifo_in_ = NULL;
    sc_fifo_out_ = NULL;

    tlm_base_initiator_socket_b_ = NULL;
    tlm_base_target_socket_b_ = NULL;
    
    sc_simcontext_ = NULL;
    sc_segid_ = NULL;
    sc_time_ = NULL;
    sc_process_b_ = NULL;
    sc_get_curr_simcontext_ = NULL;
    sc_stop_ = NULL;
    sc_get_curr_proc_ = NULL;
    sc_segid_ctor_ = NULL;
    get_upcoming_segment_ids_ = NULL;
    set_upcoming_segment_ids_ = NULL;
    get_upcoming_socket_id_ = NULL;
    set_upcoming_socket_id_ = NULL;

    increase_offset_ = NULL;
    decrease_offset_ = NULL;
    get_offset_ = NULL;

    sc_main_ = NULL;

    const std::vector<SgNode*> &class_defs = RoseNodes::get_class_defs();
    for(std::vector<SgNode*>::const_iterator
        iter  = class_defs.begin();
        iter != class_defs.end();
        iter++) {

      SgClassDefinition* class_def = isSgClassDefinition(*iter);
      std::string qualified_name = class_def->get_qualified_name();
      
      #define COMPARE_NAME(QualifiedName, Variable) \
      if(qualified_name == #QualifiedName) {        \
        Variable = class_def;                  \
        continue;                                   \
      }
      COMPARE_NAME(::sc_core::sc_module, sc_module_);
      COMPARE_NAME(::sc_core::sc_port, sc_port_);
      COMPARE_NAME(::sc_core::sc_port_base, sc_port_base_);
      COMPARE_NAME(::sc_core::sc_in, sc_in_);
      COMPARE_NAME(::sc_core::sc_inout, sc_inout_);
      COMPARE_NAME(::sc_core::sc_out, sc_out_);
      COMPARE_NAME(::sc_core::sc_event, sc_event_);
      COMPARE_NAME(::sc_core::sc_event_and_list, sc_event_and_list_);
      COMPARE_NAME(::sc_core::sc_event_or_list, sc_event_or_list_);
      COMPARE_NAME(::sc_core::sc_prim_channel, sc_prim_channel_);
      COMPARE_NAME(::sc_core::sc_interface, sc_interface_);
      COMPARE_NAME(::sc_core::sc_channel, sc_channel_);
      COMPARE_NAME(::sc_core::sc_fifo, sc_fifo_);
      COMPARE_NAME(::sc_core::sc_fifo_in, sc_fifo_in_);
      COMPARE_NAME(::sc_core::sc_fifo_out, sc_fifo_out_);
      COMPARE_NAME(::sc_core::sc_simcontext, sc_simcontext_);
      COMPARE_NAME(::sc_core::sc_segid, sc_segid_);
      COMPARE_NAME(::sc_core::sc_time, sc_time_);
      COMPARE_NAME(::sc_core::sc_process_b, sc_process_b_);
      COMPARE_NAME(::tlm::tlm_base_initiator_socket_b, tlm_base_initiator_socket_b_);
      COMPARE_NAME(::tlm::tlm_base_target_socket_b, tlm_base_target_socket_b_);

      // This is a hack! Why? All four types are in the original library
      // typedefs. However, rose has some hiccups with parsing sc_out. There is
      // no definition available. So, I introduced in the SystemC library some
      // 'fake' classes and replaced the typedefs.
      COMPARE_NAME(::sc_core::sc_in_clk, sc_in_clk_);
      COMPARE_NAME(::sc_core::sc_out_clk, sc_out_clk_);
      COMPARE_NAME(::sc_core::sc_inout_clk, sc_inout_clk_);
      #undef COMPARE_NAME
    }
    if (!sc_module_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_module" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_port_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_port" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_port_base_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_port_base" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_in_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_in" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_inout_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_inout" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_out_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_out" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_event_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_event" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_event_and_list_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_event_and_list" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_event_or_list_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_event_or_list" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_prim_channel_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_prim_channel" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_interface_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_interface" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_channel_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_channel" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_fifo_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_channel" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_fifo_in_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_fifo_in" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_fifo_out_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_fifo_out" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_simcontext_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_simcontext" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_segid_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_segid" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_time_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_time_" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_process_b_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "sc_process_b" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    /*if (!tlm_base_initiator_socket_b_) { // complain if not found (ZC, 09:09 2018/9/28)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "tlm_base_initiator_socket_b" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!tlm_base_target_socket_b_) { // complain if not found (ZC, 9:09 2018/9/28)
      std::cerr << std::endl << "ERROR: Cannot find definition of class '"
                << "tlm_base_target_socket_b" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }*/

    // Search for the SystemC Namespaces sc_core and sc_dt
    const std::vector<SgNode*> &temp_namespaces
      = risc::tools::RoseNodes::get_namespace_defs();
    for(std::vector<SgNode*>::const_iterator
        iter  = temp_namespaces.begin();
        iter != temp_namespaces.end();
        iter++) {

      SgNamespaceDefinitionStatement *namespace_def
        = isSgNamespaceDefinitionStatement(*iter);
      std::string qualified_name = namespace_def->get_qualified_name();

      #define COMPARE_NAME(QualifiedName, Variable) \
      if(qualified_name == #QualifiedName) {        \
        sc_##Variable.push_back(namespace_def);     \
        continue;                                   \
      }
      COMPARE_NAME(::sc_core, core_);
      COMPARE_NAME(::sc_dt, dt_);
      #undef COMPARE_NAME
    }
    
    if (sc_core_.size() < 187) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find 187 definitions in namespace '"
                << "sc_core" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (sc_dt_.size() < 30) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find 30 definitions in namespace '"
                << "sc_dt" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }

    // Search for all wait functions
    const std::vector<SgNode*> &temp_wait_func_def
      = risc::tools::RoseNodes::get_func_defs();

    for(std::vector<SgNode*>::const_iterator
        iter  = temp_wait_func_def.begin();
        iter != temp_wait_func_def.end();
        iter++) {

      SgFunctionDefinition *func_def = isSgFunctionDefinition(*iter);
      std::string qualified_name
        = func_def->get_declaration()->get_qualified_name();

      #define COMPARE_NAME(QualifiedName, Variable) \
      if(qualified_name == #QualifiedName) {        \
        sc_##Variable = func_def;                   \
        continue;                                   \
      }
      COMPARE_NAME(::sc_main, main_);
      #undef COMPARE_NAME

      SgClassDefinition *enclosing_class_def
        = SageInterface::getEnclosingClassDefinition(func_def);

      // Here, we are searching for the wait functions in sc_module
      // RD: there are 13 of these
      // RD: (these all call corresponding ::sc_core::wait functions)
      if(enclosing_class_def == sc_module_) {
        if(SageInterface::get_name(func_def) == "wait") {
          sc_wait_funcs_.insert(func_def);
        }
      }

      // RD: we also search for the wait functions in sc_prim_channel
      // RD: there are also 13 of those (a matching set!)
      // RD: (these also call corresponding ::sc_core::wait functions)
      if(enclosing_class_def == sc_prim_channel_) {
        if(SageInterface::get_name(func_def) == "wait") {
          sc_wait_funcs_.insert(func_def);
        }
      }
    }
// RD: in PSG mode, this won't be found, so we delay the error until it's needed
//  if (!sc_main_) { // complain if not found (RD, 07/06/18)
//    std::cerr << std::endl << "ERROR: Cannot find definition of function '"
//              << "sc_main" << "' (in source code). Aborting."
//              << std::endl;
//    exit(10);
//  }
    if (sc_wait_funcs_.size()!= 13) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find 13 definitions of function '"
                << "wait" << "' (in systemc.h). Aborting."
                << std::endl;
      exit(10);
    }

    std::vector<SgNode*> func_defs
      = NodeQuery::querySubTree(sc_process_b_, V_SgFunctionDeclaration);
    for(std::vector<SgNode*>::iterator
        iter  = func_defs.begin();
        iter != func_defs.end();
        iter++) {
      if(SageInterface::get_name(*iter) == "get_upcoming_segment_ids") {
        get_upcoming_segment_ids_ = isSgMemberFunctionDeclaration(*iter);
        get_upcoming_segment_ids_
          = isSgMemberFunctionDeclaration(
              get_upcoming_segment_ids_
                ->get_declaration_associated_with_symbol());
      }
      if(SageInterface::get_name(*iter) == "set_upcoming_segment_ids") {
        set_upcoming_segment_ids_ = isSgMemberFunctionDeclaration(*iter);
        set_upcoming_segment_ids_
          = isSgMemberFunctionDeclaration(
              set_upcoming_segment_ids_
                ->get_declaration_associated_with_symbol());
      }

      if(SageInterface::get_name(*iter) == "get_upcoming_socket_id") {
        get_upcoming_socket_id_ = isSgMemberFunctionDeclaration(*iter);
        get_upcoming_socket_id_
          = isSgMemberFunctionDeclaration(
              get_upcoming_socket_id_
                ->get_declaration_associated_with_symbol());
      }
      if(SageInterface::get_name(*iter) == "set_upcoming_socket_id") {
        set_upcoming_socket_id_ = isSgMemberFunctionDeclaration(*iter);
        set_upcoming_socket_id_
          = isSgMemberFunctionDeclaration(
              set_upcoming_socket_id_
                ->get_declaration_associated_with_symbol());
      }

      if(SageInterface::get_name(*iter) == "increase_offset") {
        increase_offset_ = isSgMemberFunctionDeclaration(*iter);
        increase_offset_
          = isSgMemberFunctionDeclaration(
              increase_offset_
                ->get_declaration_associated_with_symbol());
      }
      if(SageInterface::get_name(*iter) == "decrease_offset") {
        decrease_offset_ = isSgMemberFunctionDeclaration(*iter);
        decrease_offset_
          = isSgMemberFunctionDeclaration(
              decrease_offset_
                ->get_declaration_associated_with_symbol());
      }
      if(SageInterface::get_name(*iter) == "get_offset") {
        get_offset_ = isSgMemberFunctionDeclaration(*iter);
        get_offset_
          = isSgMemberFunctionDeclaration(
              get_offset_
                ->get_declaration_associated_with_symbol());
      }
    }
    if (!get_upcoming_segment_ids_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find declaration of function '"
                << "get_upcoming_segment_ids" << "' (in RISC systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!set_upcoming_segment_ids_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find declaration of function '"
                << "set_upcoming_segment_ids" << "' (in RISC systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!get_upcoming_socket_id_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find declaration of function '"
                << "get_upcoming_socket_id" << "' (in RISC systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!set_upcoming_socket_id_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find declaration of function '"
                << "set_upcoming_socket_id" << "' (in RISC systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!increase_offset_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find declaration of function '"
                << "increase_offset" << "' (in RISC systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!decrease_offset_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find declaration of function '"
                << "decrease_offset" << "' (in RISC systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!get_offset_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find declaration of function '"
                << "get_offset" << "' (in RISC systemc.h). Aborting."
                << std::endl;
      exit(10);
    }

    func_defs
      = NodeQuery::querySubTree(sc_simcontext_, V_SgMemberFunctionDeclaration);
    for(std::vector<SgNode*>::iterator
        iter  = func_defs.begin();
        iter != func_defs.end();
        iter++) {
      if(SageInterface::get_name(*iter) == "get_curr_proc") {
        sc_get_curr_proc_ = isSgMemberFunctionDeclaration(*iter);
        sc_get_curr_proc_
          = isSgMemberFunctionDeclaration(
              sc_get_curr_proc_->get_declaration_associated_with_symbol());
      }
    }
    if (!sc_get_curr_proc_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find declaration of function '"
                << "get_curr_proc" << "' (in RISC systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    
    func_defs
      = NodeQuery::querySubTree(sc_segid_, V_SgMemberFunctionDeclaration);
    for(std::vector<SgNode*>::iterator
        iter  = func_defs.begin();
        iter != func_defs.end();
        iter++) {
          
      if(SageInterface::get_name(*iter) == "sc_segid") {
        sc_segid_ctor_ = isSgMemberFunctionDeclaration(*iter);
        sc_segid_ctor_
          = isSgMemberFunctionDeclaration(
              sc_segid_ctor_->get_declaration_associated_with_symbol());
      }
    }
    if (!sc_segid_ctor_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find declaration of function '"
                << "sc_segid" << "' (in RISC systemc.h). Aborting."
                << std::endl;
      exit(10);
    }

    func_defs
      = NodeQuery::querySubTree(sc_port_base_, V_SgMemberFunctionDeclaration);
    for(std::vector<SgNode*>::iterator
        iter  = func_defs.begin();
        iter != func_defs.end();
        iter++) {
      if(SageInterface::get_name(*iter) == "get_interface") {
        get_interface_ = isSgMemberFunctionDeclaration(*iter);
        get_interface_
          = isSgMemberFunctionDeclaration(
              get_interface_->get_declaration_associated_with_symbol());
      }
    }
    if (!get_interface_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find declaration of function '"
                << "get_interface" << "' (in RISC systemc.h). Aborting."
                << std::endl;
      exit(10);
    }

    //elab for sockets
    //get_base_interface
    if(tlm_base_initiator_socket_b_)
    {
      func_defs
        = NodeQuery::querySubTree(tlm_base_initiator_socket_b_, V_SgMemberFunctionDeclaration);
      for(std::vector<SgNode*>::iterator
          iter  = func_defs.begin();
          iter != func_defs.end();
          iter++) {
        if(SageInterface::get_name(*iter) == "get_base_interface") {
          get_base_interface_ = isSgMemberFunctionDeclaration(*iter);
          get_base_interface_
            = isSgMemberFunctionDeclaration(
                get_base_interface_->get_declaration_associated_with_symbol());
        }
      }
      if (!get_base_interface_) { // complain if not found (RD, 07/06/18)
        // std::cerr << std::endl << "ERROR: Cannot find declaration of function '"
        //           << "get_base_interface" << "' (in RISC systemc.h). Aborting."
        //           << std::endl;
        // exit(10);
      }
    }

    //get_base_port
    if(tlm_base_target_socket_b_)
    {
      func_defs
        = NodeQuery::querySubTree(tlm_base_target_socket_b_, V_SgMemberFunctionDeclaration);
      for(std::vector<SgNode*>::iterator
          iter  = func_defs.begin();
          iter != func_defs.end();
          iter++) {
        if(SageInterface::get_name(*iter) == "get_base_port") {
          get_base_port_ = isSgMemberFunctionDeclaration(*iter);
          get_base_port_
            = isSgMemberFunctionDeclaration(
                get_base_port_->get_declaration_associated_with_symbol());
        }
      }
      if (!get_base_port_) { // complain if not found (RD, 07/06/18)
        // std::cerr << std::endl << "ERROR: Cannot find declaration of function '"
        //           << "get_base_port" << "' (in RISC systemc.h). Aborting."
        //           << std::endl;
        // exit(10);
      }
    }

    //end

    for(std::vector<SgNamespaceDefinitionStatement*>::iterator
        namespace_iter  = sc_core_.begin();
        namespace_iter != sc_core_.end();
        namespace_iter++) {

      func_defs = NodeQuery::querySubTree(
                    *namespace_iter, V_SgFunctionDeclaration);

      bool found = false;
      for(std::vector<SgNode*>::iterator
          iter  = func_defs.begin();
          iter != func_defs.end();
          iter++) {

        if(SageInterface::get_name(*iter) == "sc_get_curr_simcontext") {
          sc_get_curr_simcontext_ = isSgFunctionDeclaration(*iter);
          sc_get_curr_simcontext_
            = isSgFunctionDeclaration(
                sc_get_curr_simcontext_
                  ->get_declaration_associated_with_symbol());
          found = true;
          break;
        }
      }

      if(found) {
        break;
      }
    }

    for(std::vector<SgNamespaceDefinitionStatement*>::iterator
        namespace_iter  = sc_core_.begin();
        namespace_iter != sc_core_.end();
        namespace_iter++) {

      func_defs = NodeQuery::querySubTree(
                    *namespace_iter, V_SgFunctionDeclaration);

      bool found = false;
      for(std::vector<SgNode*>::iterator
          iter  = func_defs.begin();
          iter != func_defs.end();
          iter++) {

        if(SageInterface::get_name(*iter) == "sc_stop") {
          sc_stop_ = isSgFunctionDeclaration(*iter);
          sc_stop_
            = isSgFunctionDeclaration(
                sc_stop_
                  ->get_declaration_associated_with_symbol());
          found = true;
          break;
        }
      }

      if(found) {
        break;
      }
    }

    if (!sc_get_curr_simcontext_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find declaration of function '"
                << "sc_get_curr_simcontext" << "' (in RISC systemc.h). Aborting."
                << std::endl;
      exit(10);
    }
    if (!sc_stop_) { // complain if not found (RD, 07/06/18)
      std::cerr << std::endl << "ERROR: Cannot find declaration of function '"
                << "sc_stop" << "' (in RISC systemc.h). Aborting."
                << std::endl;
      exit(10);
    }

  #if 0
    std::cout << "sc_process_b_             " << sc_process_b_ << std::endl;
    std::cout << "sc_simcontext_            " << sc_simcontext_ << std::endl;
    std::cout << "sc_module_                " << sc_module_ << std::endl;
    std::cout << "sc_port_                  " << sc_port_  << std::endl;
    std::cout << "sc_port_base_             " << sc_port_base_ << std::endl;
    std::cout << "sc_in_                    " << sc_in_ << std::endl;
    std::cout << "sc_inout_                 " << sc_inout_ << std::endl;
    std::cout << "sc_out_                   " << sc_out_ << std::endl;
    std::cout << "sc_event_                 " << sc_event_ << std::endl;
    std::cout << "sc_event_and_list_        " << sc_event_and_list_ << std::endl;
    std::cout << "sc_event_or_list_         " << sc_event_or_list_ << std::endl;
    std::cout << "sc_prim_channel_          " << sc_prim_channel_ << std::endl;
    std::cout << "sc_channel_               " << sc_channel_ << std::endl;
    std::cout << "sc_in_clk_                " << sc_in_clk_ << std::endl;
    std::cout << "sc_out_clk_               " << sc_out_clk_ << std::endl;
    std::cout << "sc_inout_clk_             " << sc_inout_clk_ << std::endl;
    std::cout << "sc_fifo_                  " << sc_fifo_ << std::endl;
    std::cout << "sc_fifo_in_               " << sc_fifo_in_ << std::endl;
    std::cout << "sc_fifo_out_              " << sc_fifo_out_ << std::endl;
    std::cout << "sc_main_                  " << sc_main_ << std::endl;
    std::cout << "sc_core_                  " << sc_core_.size() << std::endl;
    std::cout << "sc_dt_                    " << sc_dt_.size() << std::endl;
    std::cout << "sc_wait_funcs_            " << sc_wait_funcs_.size() << std::endl;
    std::cout << "get_curr_proc_            " << sc_get_curr_proc_ << std::endl;
    std::cout << "get_curr_simcontext_      " << sc_get_curr_simcontext_ << std::endl;
    std::cout << "get_upcoming_segment_ids_ " << get_upcoming_segment_ids_ << std::endl;
    std::cout << "set_upcoming_segment_ids_ " << set_upcoming_segment_ids_ << std::endl;
  #endif

    is_initialized_ = true;
}

  /*
   * \brief Pointer to the sc_module definition in the rose ast tree
   */
  static SgClassDefinition *sc_module_;
  static SgClassDefinition *sc_port_;
  static SgClassDefinition *sc_port_base_;
  static SgClassDefinition *sc_in_;
  static SgClassDefinition *sc_out_;
  static SgClassDefinition *sc_inout_;
  static SgClassDefinition *sc_event_;
  static SgClassDefinition *sc_event_and_list_;
  static SgClassDefinition *sc_event_or_list_;
  static SgClassDefinition *sc_prim_channel_;
  static SgClassDefinition *sc_interface_;
  static SgClassDefinition *sc_fifo_;
  static SgClassDefinition *sc_fifo_in_;
  static SgClassDefinition *sc_fifo_out_;
  static SgClassDefinition *sc_simcontext_;
  static SgClassDefinition *sc_segid_;
  static SgClassDefinition *sc_time_;
  static SgClassDefinition *sc_process_b_;

  // This is a hack. Please see the comment in the source file.
  static SgClassDefinition *sc_channel_;
  static SgClassDefinition *sc_in_clk_;
  static SgClassDefinition *sc_out_clk_;
  static SgClassDefinition *sc_inout_clk_;
  
  static SgClassDefinition *tlm_base_initiator_socket_b_;
  static SgClassDefinition *tlm_base_target_socket_b_;

  static SgFunctionDefinition *sc_main_;
  static SgFunctionDeclaration *sc_get_curr_simcontext_;
  static SgFunctionDeclaration *sc_stop_;
  static SgMemberFunctionDeclaration *sc_get_curr_proc_;
  static SgMemberFunctionDeclaration *sc_segid_ctor_;
  static SgMemberFunctionDeclaration *get_upcoming_segment_ids_;
  static SgMemberFunctionDeclaration *set_upcoming_segment_ids_;
  static SgMemberFunctionDeclaration *get_upcoming_socket_id_;
  static SgMemberFunctionDeclaration *set_upcoming_socket_id_;

  static SgMemberFunctionDeclaration *increase_offset_;
  static SgMemberFunctionDeclaration *decrease_offset_;
  static SgMemberFunctionDeclaration *get_offset_;

  static SgMemberFunctionDeclaration *get_interface_;
  static SgMemberFunctionDeclaration *get_base_interface_;
  static SgMemberFunctionDeclaration *get_base_port_;

  // Namespace of systemc
  static std::vector<SgNamespaceDefinitionStatement*> sc_core_;
  static std::vector<SgNamespaceDefinitionStatement*> sc_dt_;

  // Wait functions
  static std::set<SgFunctionDefinition*> sc_wait_funcs_;

  static bool is_initialized_;

}; // end of namespace tools

}; // end of namespace risc


/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
