#include <iostream>

#include "risc.h"

int main(int argc, char* argv[])
{
  std::cout << std::endl
            << "start processing file: " __FILE__
            << " ..."
            << std::endl;

  risc::Design design(argc,argv);

  risc::InstanceTree::Element tb_top;
  risc::InstanceTree::Element top_c;
  risc::InstanceTree::Element top_f;
  risc::InstanceTree::Element c_b;
  risc::InstanceTree::Element b_a1;
  risc::InstanceTree::Element b_a2;
  risc::InstanceTree::Element b_a3;
  risc::InstanceTree::Element a_a_ref;
  risc::InstanceTree::Element a_a_ref2;
  risc::InstanceTree::Element a_a_ref3;
  risc::InstanceTree::Element a_a_ref4;
  risc::InstanceTree::Element a_a_ref5;
  risc::InstanceTree::Element a_a_value;
  risc::InstanceTree::Element a_a_event;
  risc::InstanceTree::Element f_e;
  risc::InstanceTree::Element e_d;
  risc::InstanceTree::Element d_d_ref;


  // iterating all modules in the design
  for(risc::ModuleVectorIter
      iter  = design.module_definitions_.begin();
      iter != design.module_definitions_.end();
      iter++) {

    // print all sub modules in the individual module definitions
    (*iter)->print_module_definition();
    std::cout << std::endl;

    if((*iter)->get_name() == "Testbench") {
      tb_top.first = *iter;

      for(risc::ModuleInstanceVector::iterator
          sub_module_iter  = (*iter)->sub_modules_.begin();
          sub_module_iter != (*iter)->sub_modules_.end();
          sub_module_iter++) {
        if((*sub_module_iter)->get_name() == "top") {
          tb_top.second = *sub_module_iter;
        }
      }
    }

    if((*iter)->get_name() == "Top") {
      top_c.first = *iter;
      top_f.first = *iter;

      for(risc::ModuleInstanceVector::iterator
          sub_module_iter  = (*iter)->sub_modules_.begin();
          sub_module_iter != (*iter)->sub_modules_.end();
          sub_module_iter++) {
        if((*sub_module_iter)->get_name() == "c") {
          top_c.second = *sub_module_iter;
        }
        if((*sub_module_iter)->get_name() == "f") {
          top_f.second = *sub_module_iter;
        }
      }
    }

    if((*iter)->get_name() == "C") {
      c_b.first = *iter;

      for(risc::ModuleInstanceVector::iterator
          sub_module_iter  = (*iter)->sub_modules_.begin();
          sub_module_iter != (*iter)->sub_modules_.end();
          sub_module_iter++) {
        if((*sub_module_iter)->get_name() == "b") {
          c_b.second = *sub_module_iter;
        }
      }
    }

    if((*iter)->get_name() == "B") {
      b_a1.first = *iter;
      b_a2.first = *iter;
      b_a3.first = *iter;

      for(risc::ModuleInstanceVector::iterator
          sub_module_iter  = (*iter)->sub_modules_.begin();
          sub_module_iter != (*iter)->sub_modules_.end();
          sub_module_iter++) {
        if((*sub_module_iter)->get_name() == "a1") {
          b_a1.second = *sub_module_iter;
        }
        if((*sub_module_iter)->get_name() == "a2") {
          b_a2.second = *sub_module_iter;
        }
        if((*sub_module_iter)->get_name() == "a3") {
          b_a3.second = *sub_module_iter;
        }
      }
    }

    if((*iter)->get_name() == "A") {
      a_a_ref.first = *iter;
      a_a_ref2.first = *iter;
      a_a_ref3.first = *iter;
      a_a_ref4.first = *iter;
      a_a_ref5.first = *iter;
      a_a_value.first = *iter;
      a_a_event.first = *iter;

      for(risc::VariableVector::iterator
          variable_iter  = (*iter)->variables_.begin();
          variable_iter != (*iter)->variables_.end();
          variable_iter++) {
        if((*variable_iter)->get_name() == "a_ref") {
          a_a_ref.second = *variable_iter;
        }
        if((*variable_iter)->get_name() == "a_ref2") {
          a_a_ref2.second = *variable_iter;
        }
        if((*variable_iter)->get_name() == "a_ref3") {
          a_a_ref3.second = *variable_iter;
        }
        if((*variable_iter)->get_name() == "a_ref4") {
          a_a_ref4.second = *variable_iter;
        }
        if((*variable_iter)->get_name() == "a_ref5") {
          a_a_ref5.second = *variable_iter;
        }
        if((*variable_iter)->get_name() == "a_value") {
          a_a_value.second = *variable_iter;
        }
      }

      for(risc::EventVector::iterator
          event_iter  = (*iter)->events_.begin();
          event_iter != (*iter)->events_.end();
          event_iter++) {

        if((*event_iter)->get_name() == "a_event") {
          a_a_event.second = *event_iter;
        }
      }
    }

    if((*iter)->get_name() == "F") {
      f_e.first = *iter;

      for(risc::ModuleInstanceVector::iterator
          sub_module_iter  = (*iter)->sub_modules_.begin();
          sub_module_iter != (*iter)->sub_modules_.end();
          sub_module_iter++) {
        if((*sub_module_iter)->get_name() == "e") {
          f_e.second = *sub_module_iter;
        }
      }
    }

    if((*iter)->get_name() == "E") {
      e_d.first = *iter;

      for(risc::ModuleInstanceVector::iterator
          sub_module_iter  = (*iter)->sub_modules_.begin();
          sub_module_iter != (*iter)->sub_modules_.end();
          sub_module_iter++) {
        if((*sub_module_iter)->get_name() == "d") {
          e_d.second = *sub_module_iter;
        }
      }
    }

    if((*iter)->get_name() == "D") {
      d_d_ref.first = *iter;

      for(risc::VariableVector::iterator
          variable_iter  = (*iter)->variables_.begin();
          variable_iter != (*iter)->variables_.end();
          variable_iter++) {
        if((*variable_iter)->get_name() == "d_ref") {
          d_d_ref.second = *variable_iter;
        }
      }
    }
  }

  std::cout << "Global variables" << std::endl;
  for(risc::VariableVector::iterator
      iter  = design.global_variables_.begin();
      iter != design.global_variables_.end();
      iter++) {
    std::cout << "  " << (*iter)->get_ast_type_name()
              << " " << (*iter)->get_name() << std::endl;
  }

  risc::InstanceTree a__a_ref;
  a__a_ref.path_.push_back(tb_top);
  a__a_ref.path_.push_back(top_c);
  a__a_ref.path_.push_back(c_b);
  a__a_ref.path_.push_back(b_a1);
  a__a_ref.path_.push_back(a_a_ref);
  a__a_ref.print_instance_tree();

  risc::InstanceTree a__a_ref_2;
  a__a_ref_2.path_.push_back(tb_top);
  a__a_ref_2.path_.push_back(top_c);
  a__a_ref_2.path_.push_back(c_b);
  a__a_ref_2.path_.push_back(b_a1);
  a__a_ref_2.path_.push_back(a_a_ref2);
  a__a_ref_2.print_instance_tree();

  risc::InstanceTree a__a_ref_3;
  a__a_ref_3.path_.push_back(tb_top);
  a__a_ref_3.path_.push_back(top_c);
  a__a_ref_3.path_.push_back(c_b);
  a__a_ref_3.path_.push_back(b_a1);
  a__a_ref_3.path_.push_back(a_a_ref3);
  a__a_ref_3.print_instance_tree();

  risc::InstanceTree a__a_value;
  a__a_value.path_.push_back(tb_top);
  a__a_value.path_.push_back(top_c);
  a__a_value.path_.push_back(c_b);
  a__a_value.path_.push_back(b_a1);
  a__a_value.path_.push_back(a_a_value);
  a__a_value.print_instance_tree();

  risc::InstanceTree a__a_event;
  a__a_event.path_.push_back(tb_top);
  a__a_event.path_.push_back(top_c);
  a__a_event.path_.push_back(c_b);
  a__a_event.path_.push_back(b_a1);
  a__a_event.path_.push_back(a_a_event);
  a__a_event.print_instance_tree();

  risc::InstanceTree a__a_ref_4;
  a__a_ref_4.path_.push_back(tb_top);
  a__a_ref_4.path_.push_back(top_c);
  a__a_ref_4.path_.push_back(c_b);
  a__a_ref_4.path_.push_back(b_a1);
  a__a_ref_4.path_.push_back(a_a_ref4);
  a__a_ref_4.print_instance_tree();

  risc::InstanceTree a__a_ref_5;
  a__a_ref_5.path_.push_back(tb_top);
  a__a_ref_5.path_.push_back(top_c);
  a__a_ref_5.path_.push_back(c_b);
  a__a_ref_5.path_.push_back(b_a1);
  a__a_ref_5.path_.push_back(a_a_ref5);
  a__a_ref_5.print_instance_tree();

  std::cout << std::endl;

  std::cout << "+++++++++++++++++++" << std::endl;
  risc::InstanceTree mapped_a__a_ref = a__a_ref.get_real_mapped_variable();
  std::cout << "+++++++++++++++++++" << std::endl;
  risc::InstanceTree mapped_a__a_ref2 = a__a_ref_2.get_real_mapped_variable();
  std::cout << "+++++++++++++++++++" << std::endl;
  risc::InstanceTree mapped_a__a_value = a__a_value.get_real_mapped_variable();
  std::cout << "+++++++++++++++++++" << std::endl;
  risc::InstanceTree mapped_a__a_event = a__a_event.get_real_mapped_variable();
  std::cout << "+++++++++++++++++++" << std::endl;
  risc::InstanceTree mapped_a__a_ref3 = a__a_ref_3.get_real_mapped_variable();
  std::cout << "+++++++++++++++++++" << std::endl;
  risc::InstanceTree mapped_a__a_ref4 = a__a_ref_4.get_real_mapped_variable();
  std::cout << "+++++++++++++++++++" << std::endl;
  risc::InstanceTree mapped_a__a_ref5 = a__a_ref_5.get_real_mapped_variable();
  std::cout << "+++++++++++++++++++" << std::endl;

  std::cout << "+++++++++++++++++++++++++++++++++++++++++++++++++" << std::endl;
  std::cout << "++++             check the mapping           ++++" << std::endl;
  std::cout << "+++++++++++++++++++++++++++++++++++++++++++++++++" << std::endl;

  a__a_ref.print_instance_tree();
  std::cout << " -> " << std::endl;
  mapped_a__a_ref.print_instance_tree();

  std::cout << std::endl;

  a__a_ref_2.print_instance_tree();
  std::cout << " -> " << std::endl;
  mapped_a__a_ref2.print_instance_tree();

  std::cout << std::endl;

  a__a_value.print_instance_tree();
  std::cout << " -> " << std::endl;
  mapped_a__a_value.print_instance_tree();

  std::cout << std::endl;

  a__a_event.print_instance_tree();
  std::cout << " -> " << std::endl;
  mapped_a__a_event.print_instance_tree();

  std::cout << std::endl;

  a__a_ref_3.print_instance_tree();
  std::cout << " -> " << std::endl;
  mapped_a__a_ref3.print_instance_tree();

  std::cout << std::endl;

  a__a_ref_4.print_instance_tree();
  std::cout << " -> " << std::endl;
  mapped_a__a_ref4.print_instance_tree();

  std::cout << std::endl;

  a__a_ref_5.print_instance_tree();
  std::cout << " -> " << std::endl;
  mapped_a__a_ref5.print_instance_tree();

  std::cout << "+++++++++++++++++++++++++++++++++++++++++++++++++" << std::endl;
  std::cout << "++++             check the finder            ++++" << std::endl;
  std::cout << "+++++++++++++++++++++++++++++++++++++++++++++++++" << std::endl;


  a__a_value.print_instance_tree();
  std::list<risc::InstanceTree> all_mapped_a_value =
    a__a_value.find_all_instances_of(risc::tools::get_sym_from_def(
      a_a_value.second->get_ast_node()));

  std::cout << "found at: " << std::endl;
  for(std::list<risc::InstanceTree>::iterator
      iter  = all_mapped_a_value.begin();
      iter != all_mapped_a_value.end();
      iter++) {
    std::cout << "  ";
    (*iter).print_instance_tree();
  }


  std::cout << std::endl;

  risc::InstanceTree top;
  top.path_.push_back(tb_top);
  all_mapped_a_value =
    top.find_all_instances_of(risc::tools::get_sym_from_def(
      a_a_value.second->get_ast_node()));

  top.print_instance_tree();

  std::cout << "found at: " << std::endl;
  for(std::list<risc::InstanceTree>::iterator
      iter  = all_mapped_a_value.begin();
      iter != all_mapped_a_value.end();
      iter++) {
    std::cout << "  ";
    (*iter).print_instance_tree();
  }

  std::cout << std::endl;

  std::cout << "end processing file: " __FILE__
            << " ..."
            << std::endl
            << std::endl;

  return 0;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
