/*****************************************************************************

  The following code is derived, directly or indirectly, from the SystemC
  source code Copyright (c) 1996-2006 by all Contributors.
  All Rights reserved.

  The contents of this file are subject to the restrictions and limitations
  set forth in the SystemC Open Source License Version 2.4 (the "License");
  You may not use this file except in compliance with such restrictions and
  limitations. You may obtain instructions on how to receive a copy of the
  License at http://www.systemc.org/. Software distributed by Contributors
  under the License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF
  ANY KIND, either express or implied. See the License for the specific
  language governing rights and limitations under the License.

 *****************************************************************************/

/*****************************************************************************

  simple_fifo.cpp -- Simple SystemC 2.0 producer/consumer example.

                     From "An Introduction to System Level Modeling in
                     SystemC 2.0". By Stuart Swan, Cadence Design Systems.
                     Available at www.systemc.org

  Original Author: Stuart Swan, Cadence Design Systems, 2001-06-18

 *****************************************************************************/

/*****************************************************************************

  MODIFICATION LOG - modifiers, enter your name, affiliation, date and
  changes you are making here.

      Name, Affiliation, Date: Ajit Dingankar, Intel Corporation, 2017-10-09
  Description of Modification: Simple changes to bring closer to SystemC code
  	  generated by Intel(R) CoFluent(TM) Studio

 *****************************************************************************/


#include <systemc.h>
#include "fifo.h"
#include "prod.h"
#include "cons.h"
void func(int x){

  //return x;
}

/*
class producer : public sc_module {
  public:
    sc_port<write_if> out;

    SC_HAS_PROCESS(producer);

    producer(sc_module_name name) : sc_module(name) {
      SC_THREAD(loop);
    }

    void loop() {
      const char *str = "Hello_SystemC\0";
      char c;

      while (*str) {
        wait(SC_ZERO_TIME);
        c = *str;
        out->write(c);          
        str++;
        //cout << "producer: " << c << " >>" << endl
            //<< flush
        ;
      }
    }
};
*/

/*
class consumer : public sc_module {
  public:
    sc_port<read_if> in;

    SC_HAS_PROCESS(consumer);

    consumer(sc_module_name name) : sc_module(name) {
      SC_THREAD(loop);
    }

    void loop() {
      char c;
      //cout << endl << endl;

      while (true) {
        wait(SC_ZERO_TIME);
        in->read(c);
        cout << ">> consumer: " << c << endl;
            
      }
    }
};
*/

class top : public sc_module {
public:
  fifo fifo_inst;
  producer prod_inst;
  consumer cons_inst;

  top(sc_module_name name) : 
  sc_module(name),
  fifo_inst("Fifo1"),
  prod_inst("Producer1"),
  cons_inst("Consumer1")
  {	  

    prod_inst.out(fifo_inst); 
    cons_inst.in(fifo_inst);
  }
};

int sc_main (int, char *[]) {
 top top1("Top1");
 sc_start();
 return 0;
}
