#include <string>
#include "systemc.h"
using namespace sc_core;
using namespace std;

SC_MODULE(Stimulus)
{
  int video;

  bool testRD_noWait(void)	// RD: testing code decomposition
  {
    std::cout << "in testRD_noWait" << std::endl;
    return 42;
  }

  bool testRD_indirectWait(void)	// ZC: testing code decomposition
  {
    std::cout << "in testRD_indirectWait" << std::endl;
    return testRD_withWait() + testRD_withWait() + 1;
  }

  bool testRD_withWait(void)	// RD: testing code decomposition
  {
    bool result = (42 == 27+15);

    std::cout << "in testRD_withWait, before wait" << std::endl;
    wait(SC_ZERO_TIME);
    std::cout << "in testRD_withWait, after wait" << std::endl;
    return (result);
  }

  void Th()
  {
    int a = 10;

    std::cout << "test if noWait" << std::endl;
    if(testRD_noWait())
    {
    	std::cout << "in if noWait" << std::endl;
    }

    std::cout << "test if" << std::endl;
    // TODO FIXME: Short-circuit evaluation not supported yet (04/20/19, RD)
    if(1&&testRD_withWait()&&testRD_indirectWait())
    {
    	std::cout << "in if" << std::endl;
    }

    std::cout << "test while" << std::endl;
    // TODO FIXME: Short-circuit evaluation not supported yet (04/20/19, RD)
    while(false&&testRD_withWait()&&testRD_indirectWait())
    {
    	std::cout << "in while" << std::endl;
    }

    std::cout << "test do-while" << std::endl;
    do// RD: testing code decomposition
    {
    	std::cout << "in dowhile" << std::endl;
    // TODO FIXME: Short-circuit evaluation not supported yet (04/20/19, RD)
    }while(testRD_withWait()&& false);

    std::cout << "test switch-case" << std::endl;
    switch(1+testRD_withWait()+testRD_indirectWait()){
    	case 1: {
    		std::cout << "in switch-case" << std::endl;
    		break;
		}
    	default: {
    		std::cout << "default" << std::endl;
		}
    }

    std::cout << "test for-loop" << std::endl;
    for(int i=1+testRD_withWait()+testRD_indirectWait();
    	i < 4+testRD_withWait()+testRD_indirectWait();
    	i = i+testRD_withWait()+testRD_indirectWait()){
    	std::cout << "in for" << std::endl;
    }

    std::cout << "done" << std::endl;
  }

  SC_HAS_PROCESS(Stimulus);

  Stimulus(sc_module_name n)
  : sc_module(n)
  {
    video = 3;
    SC_THREAD(Th);
  }
};

int sc_main(int   argc, char  *argv[] )
{
  Stimulus top("Stimulus");

  sc_core::sc_start();
  return 0;
}
